//////////////////////////////////////////////////////////////////////
// Created by SmartDesign Mon Feb 26 14:38:47 2018
// Version: PolarFire v2.0 12.200.0.20
//////////////////////////////////////////////////////////////////////

`timescale 1ns / 100ps

// Alpha_Blending_Control_IP0
module Alpha_Blending_Control_IP0(
    // Inputs
    RESET_n_I,
    SYS_CLK_I,
    frame_data_i,
    frame_height_i,
    frame_valid_i,
    frame_width_i,
    fx_i,
    fy_i,
    global_alpha_i,
    image_data_i,
    image_height_i,
    image_valid_i,
    image_width_i,
    video_param_valid_i,
    // Outputs
    alpha_blend_proc_compl_o,
    frame_one_line_done_o,
    vout_o,
    vout_valid_o,
    write_image_next_line_o
);

//--------------------------------------------------------------------
// Input
//--------------------------------------------------------------------
input         RESET_n_I;
input         SYS_CLK_I;
input  [23:0] frame_data_i;
input  [10:0] frame_height_i;
input         frame_valid_i;
input  [10:0] frame_width_i;
input  [10:0] fx_i;
input  [10:0] fy_i;
input  [7:0]  global_alpha_i;
input  [31:0] image_data_i;
input  [10:0] image_height_i;
input         image_valid_i;
input  [10:0] image_width_i;
input         video_param_valid_i;
//--------------------------------------------------------------------
// Output
//--------------------------------------------------------------------
output        alpha_blend_proc_compl_o;
output        frame_one_line_done_o;
output [23:0] vout_o;
output        vout_valid_o;
output        write_image_next_line_o;
//--------------------------------------------------------------------
// Nets
//--------------------------------------------------------------------
wire          alpha_blend_proc_compl_o_net_0;
wire   [23:0] frame_data_i;
wire   [10:0] frame_height_i;
wire          frame_one_line_done_o_net_0;
wire          frame_valid_i;
wire   [10:0] frame_width_i;
wire   [10:0] fx_i;
wire   [10:0] fy_i;
wire   [7:0]  global_alpha_i;
wire   [31:0] image_data_i;
wire   [10:0] image_height_i;
wire          image_valid_i;
wire   [10:0] image_width_i;
wire          RESET_n_I;
wire          SYS_CLK_I;
wire          video_param_valid_i;
wire   [23:0] vout_o_net_0;
wire          vout_valid_o_net_0;
wire          write_image_next_line_o_net_0;
wire          vout_valid_o_net_1;
wire          write_image_next_line_o_net_1;
wire          frame_one_line_done_o_net_1;
wire          alpha_blend_proc_compl_o_net_1;
wire   [23:0] vout_o_net_1;
//--------------------------------------------------------------------
// Top level output port assignments
//--------------------------------------------------------------------
assign vout_valid_o_net_1             = vout_valid_o_net_0;
assign vout_valid_o                   = vout_valid_o_net_1;
assign write_image_next_line_o_net_1  = write_image_next_line_o_net_0;
assign write_image_next_line_o        = write_image_next_line_o_net_1;
assign frame_one_line_done_o_net_1    = frame_one_line_done_o_net_0;
assign frame_one_line_done_o          = frame_one_line_done_o_net_1;
assign alpha_blend_proc_compl_o_net_1 = alpha_blend_proc_compl_o_net_0;
assign alpha_blend_proc_compl_o       = alpha_blend_proc_compl_o_net_1;
assign vout_o_net_1                   = vout_o_net_0;
assign vout_o[23:0]                   = vout_o_net_1;
//--------------------------------------------------------------------
// Component instances
//--------------------------------------------------------------------
//--------alpha_blend_control   -   Microsemi:SolutionCore:alpha_blend_control:2.0.0
alpha_blend_control #( 
        .g_FRAME_BUFFER_AWIDTH      ( 11 ),
        .g_FRAME_DATAWIDTH          ( 24 ),
        .g_FRAME_X_Y_DATAWIDTH      ( 11 ),
        .g_IMAGE_BUFFER_AWIDTH      ( 11 ),
        .g_IMAGE_DATAWIDTH          ( 32 ),
        .g_IMAGE_X_Y_DATAWIDTH      ( 11 ),
        .g_OUTPUT_CHANNEL_DATAWIDTH ( 24 ) )
Alpha_Blending_Control_IP0_0(
        // Inputs
        .SYS_CLK_I                ( SYS_CLK_I ),
        .RESET_n_I                ( RESET_n_I ),
        .video_param_valid_i      ( video_param_valid_i ),
        .image_data_i             ( image_data_i ),
        .image_valid_i            ( image_valid_i ),
        .frame_data_i             ( frame_data_i ),
        .frame_valid_i            ( frame_valid_i ),
        .fx_i                     ( fx_i ),
        .fy_i                     ( fy_i ),
        .frame_width_i            ( frame_width_i ),
        .frame_height_i           ( frame_height_i ),
        .image_width_i            ( image_width_i ),
        .image_height_i           ( image_height_i ),
        .global_alpha_i           ( global_alpha_i ),
        // Outputs
        .vout_o                   ( vout_o_net_0 ),
        .vout_valid_o             ( vout_valid_o_net_0 ),
        .write_image_next_line_o  ( write_image_next_line_o_net_0 ),
        .frame_one_line_done_o    ( frame_one_line_done_o_net_0 ),
        .alpha_blend_proc_compl_o ( alpha_blend_proc_compl_o_net_0 ) 
        );


endmodule
